function CdSIniciar () {
	var ferramentasFx = document.getElementById("menu_ToolsPopup");
	var ferramentasSm = document.getElementById("taskPopup");
	var contexto = document.getElementById("contentAreaContextMenu");

	if (ferramentasFx)
		ferramentasFx.addEventListener("popupshowing", CdSAtualizarMenu, false);

	if (ferramentasSm)
		ferramentasSm.addEventListener("popupshowing", CdSAtualizarMenu, false);

	if (contexto)
		contexto.addEventListener("popupshowing", CdSAtualizarMenu, false);

	if (CdSUtil.obterBooleana("extensions.controledescripts.shortcut.enabled")) {
		var key = document.createElement("key");

		key.id = "key_openCdS";
		key.setAttribute("command", "cmd_openCdS");
		key.setAttribute("modifiers", CdSUtil.obterString("extensions.controledescripts.shortcut.modifiers"));
		key.setAttribute("key", CdSUtil.obterString("extensions.controledescripts.shortcut.key"));

		document.getElementById("controledescripts-keyset").appendChild(key);
	}

	CdSAtualizarPrefs(false);
	CdSObservador.atualizarComando();
}

function CdSAbrirPrefs () {
	var recursos = "centerscreen,chrome,resizable";

	openDialog("chrome://controledescripts/content/prefs.xul", "controledescripts-prefs", recursos);
}

function CdSAtualizarBotao () {
	var sep = document.getElementById("navegacao-sep");
	var item = document.getElementById("navegacao-item");
	var menu = document.getElementById("navegacao-menu");
	var politicas = null;

	if (CdSUtil.existePreferencia("capability.policy.policynames"))
		politicas = CdSUtil.obterString("capability.policy.policynames");

	if (politicas) {
		item.setAttribute("class", "default");
		sep.hidden = menu.hidden = false;
	}
	else {
		item.removeAttribute("class");
		sep.hidden = menu.hidden = true;
	}
}

function CdSAtualizarIcone () {
	var broadcaster = document.getElementById("brd_menuCdS");
	var exibirIcone = CdSUtil.obterBooleana("extensions.controledescripts.showIcons");

	broadcaster.setAttribute("class", (exibirIcone ? broadcaster.getAttribute("menuclass") : ""));
}

function CdSAtualizarMenu () {
	var item = document.getElementById("ferramentas-item");
	var menu = document.getElementById("ferramentas-menu");
	var jsAtivado = CdSUtil.obterBooleana("javascript.enabled");
	var exibirMenu = CdSUtil.obterBooleana("extensions.controledescripts.showMenuitem.tools");
	var conteudoValido = true;

	if (gContextMenu) {
		item = document.getElementById("contexto-item");
		menu = document.getElementById("contexto-menu");
		exibirMenu = CdSUtil.obterBooleana("extensions.controledescripts.showMenuitem.context") && jsAtivado;
		conteudoValido = !gContextMenu.onImage && !gContextMenu.onTextInput &&
		                 !gContextMenu.isTextSelected && !gContextMenu.isContentSelected &&
		                 !gContextMenu.onMathML && (!gContextMenu.onLink || gContextMenu.onSaveableLink);
	}

	if (exibirMenu && conteudoValido) {
		var politicas = null;

		if (CdSUtil.existePreferencia("capability.policy.policynames"))
			politicas = CdSUtil.obterString("capability.policy.policynames");

		if (politicas && jsAtivado) {
			item.hidden = !(menu.hidden = false);

			if (gContextMenu) {
				document.getElementById("menu-site").hidden = gContextMenu.onSaveableLink;
				document.getElementById("menu-link").hidden = !gContextMenu.onSaveableLink;
			}
		}
		else
			item.hidden = !(menu.hidden = true);
	}
	else
		item.hidden = menu.hidden = true;

	CdSAtualizarIcone();
}

function CdSAtualizarPrefs (manterCompatibilidade) {
	if (CdSUtil.existePreferencia("controledescripts.ocultarmenu")) {
		CdSUtil.salvarString("extensions.controledescripts.showMenuitem.tools", !CdSUtil.obterBooleana("controledescripts.ocultarmenu"));
		if (!manterCompatibilidade)
			CdSUtil.limparPreferencia("controledescripts.ocultarmenu");
	}

	if (CdSUtil.existePreferencia("controledescripts.exibiricones")) {
		CdSUtil.salvarString("extensions.controledescripts.showIcons", CdSUtil.obterBooleana("controledescripts.exibiricones"));
		if (!manterCompatibilidade)
			CdSUtil.limparPreferencia("controledescripts.exibiricones");
	}
}

function CdSEditarSites (nomePol, salvar, sites) {
	if (salvar)
		CdSUtil.salvarString("capability.policy."+nomePol+".sites", sites);
	else {
		var endereco = (gContextMenu && gContextMenu.onSaveableLink) ? gContextMenu.link.href : window._content.document.location.href;
		var lista = CdSUtil.obterString("capability.policy."+nomePol+".sites");
		openDialog("chrome://controledescripts/content/dialogs/sites.xul",
		           "controledescripts-sites", "chrome,centerscreen",
		           {nomePol: nomePol, sites: lista, siteP: endereco});
	}
}

function CdSPreencherPoliticas (popup) {
	var politicas = null;

	if (CdSUtil.existePreferencia("capability.policy.policynames"))
		politicas = CdSUtil.obterString("capability.policy.policynames");

	if (politicas) {
		var itens = popup.childNodes;
		politicas = politicas.split(/\s|,/);

		for (var i = itens.length; i > 0; i--)
			popup.removeChild(popup.lastChild);

		for (i in politicas) {
			var menuitem = document.createElement("menuitem");

			menuitem.setAttribute("label", decodeURIComponent(politicas[i]));
			menuitem.setAttribute("oncommand", "CdSEditarSites('"+politicas[i]+"', false);");
			popup.appendChild(menuitem);
		}
	}
}

function CdSSair () {
	window.removeEventListener("load", CdSIniciar, false);
	window.removeEventListener("unload", CdSSair, false);
	CdSUtil.sBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal)
	               .removeObserver(CdSObservador.preferencia, CdSObservador);
}

var CdSObservador = {
	preferencia: "javascript.enabled",

	observe: function (assunto, topico, preferencia) {
		if (topico == "nsPref:changed" && preferencia == this.preferencia)
			this.atualizarComando();
	},

	atualizarComando: function () {
		var comando = document.getElementById("cmd_openCdS");

		if (CdSUtil.obterBooleana(this.preferencia))
			comando.removeAttribute("disabled");
		else
			comando.setAttribute("disabled", true);
	}
}

////////////////////////////////////////////////////////////////////////////////

window.addEventListener("load", CdSIniciar, false);
window.addEventListener("unload", CdSSair, false);
CdSUtil.sBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal)
               .addObserver(CdSObservador.preferencia, CdSObservador, false);
